#include <cuda.h>
#include <cuda_runtime.h>
#include "cudaFunction.cu"

extern "C" void cSobelInCuda(unsigned char* dstMat, const unsigned char* srcMat, const int srcHeight, const int srcWidth)
{
	dim3 threads(16, 16);
	dim3 blocks((srcHeight* 3+ 15)/ 16, (srcWidth* 3+ 15)/16);
	sobelInCuda<<<blocks, threads>>>(dstMat, srcMat, srcHeight, srcWidth);
}
