#ifndef    _MYCUDA_KERNEL_H_
#define   _MYCUDA_KERNEL_H_

__global__ static void sobelInCuda(unsigned char* dstMat, const unsigned char* dataIn, const int srcHeight, const int imgWidth)
{
	const unsigned int xIndex = blockIdx.x* blockDim.x+ threadIdx.x;
	const unsigned int yIndex = blockIdx.y* blockDim.y+ threadIdx.y;
	
	int Gx = 0;
	int Gy = 0;

	if(xIndex > 0 && xIndex < imgWidth - 1 && yIndex > 0 && yIndex < srcHeight - 1)
	{

		Gx = dataIn[(yIndex - 1) * imgWidth + xIndex + 1] + 2 * dataIn[yIndex * imgWidth + xIndex + 1] + dataIn[(yIndex + 1) * imgWidth + xIndex + 1]
		- (dataIn[(yIndex - 1) * imgWidth + xIndex - 1] + 2 * dataIn[yIndex * imgWidth + xIndex - 1] + dataIn[(yIndex + 1) * imgWidth + xIndex - 1]);
		
		Gy = dataIn[(yIndex - 1) * imgWidth + xIndex - 1] + 2 * dataIn[(yIndex - 1) * imgWidth + xIndex] + dataIn[(yIndex - 1) * imgWidth + xIndex + 1]
		- (dataIn[(yIndex + 1) * imgWidth + xIndex - 1] + 2 * dataIn[(yIndex + 1) * imgWidth + xIndex] + dataIn[(yIndex + 1) * imgWidth + xIndex + 1]);

		
		dstMat[xIndex+yIndex*imgWidth] = (abs(Gx) + abs(Gy)) / 2;
	}
}
#endif